<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "РђСЃС‚СЂР° Р’РµР±С‚РµС…РЅРѕР»РѕРіРёРё"
 * @author Vitaly Hohlov <vitaly.hohlov@gmail.com>
 * @package Modules
 */
/**************************************************************************/

class RoboPayModule extends A_MainFrame
{
  public $section;

  function __construct()
  {
    if(!$this->section=getSectionByModule('shoplite'))
    A::NotFound();

    parent::__construct();
  }

  function Router($uri)
  {
	if(count($uri)==1)
	{ if(preg_match("/([^.]+)\.html$/",reset($uri),$match))
      switch($match[1])
	  { case "result":
		  $this->Result();
		  return;
		case "success":
		case "fail":
		  $this->page=$match[1];
		  return;
	    default:
		  A::NotFound();
      }
	  else
	  A::NotFound();
    }
	elseif(count($uri)==0)
	$this->page="main";
	else
	A::NotFound();
  }

  function Result()
  {
	if(empty($_POST))
	die('bad sign\n');

    $inv_id = (integer)$_POST["InvId"];
    $out_summ = $_POST["OutSum"];
    $crc = strtoupper($_POST["SignatureValue"]);
    $crc2 = strtoupper(md5("{$out_summ}:{$inv_id}:".A::$OPTIONS['password2']));

 	if($crc2==$crc)
	{ if($order=A::$DB->getRowById($inv_id,"{$this->section}_orders"))
	  {
		A::$DB->Update("{$this->section}_orders",array('status'=>1,'pay'=>3),"id=$inv_id");

		if(!empty(A::$OPTIONS['email']) && !empty(A::$OPTIONS['mailpay']))
	    { $order['basket']=!empty($order['basket'])?@unserialize($order['basket']):array();
		  $order['userdata']=!empty($order['userdata'])?@unserialize($order['userdata']):array();
		  $all=array('count'=>0,'oldsum'=>0,'sum'=>0,'discount'=>0);
		  foreach($order['basket'] as $i=>$row)
		  { $all['count']+=$row['count'];
	        $all['oldsum']+=$row['oldsum'];
	        $all['sum']+=$row['sum'];
	        $all['discount']+=$row['discount'];
	      }
	      $mail = new A_Mail(A::$OPTIONS['mailpay']);
		  $mail->Assign("order",$order);
          $mail->Assign("basket",$order['basket']);
          $mail->Assign("data",$order['userdata']);
          $mail->Assign('all',$all);
	      $mail->send(A::$OPTIONS['email']);
	    }

		die("OK$inv_id\n");
	  }
	}
	die('bad sign\n');
  }

  function Action($action)
  {
    if($action=='pay') $this->Pay();
  }

  function Pay()
  {
	$idorder=!empty($_REQUEST['id'])?(integer)$_REQUEST['id']:A_Session::get($this->section."_idorder",0);

	if($order=A::$DB->getRowById($idorder,$this->section."_orders"))
	{
	  if(!empty($_REQUEST['code']) && $_REQUEST['code']==md5(SECTION.$order['date']))
	  {
	    if($order['status']>0)
	    A::goUrl(getSectionLink(SECTION)."success.html");

		$inv_id=$order['id'];
	    $mrh_login=A::$OPTIONS['login'];
	    $inv_desc = urlencode(HOSTNAME.": оплата заказа №{$inv_id}");
        $out_summ = (float)$order['sum'];

        if($out_summ==0)
        A::goUrl(getSectionLink(SECTION));

        $crc  = md5("$mrh_login:$out_summ:$inv_id:".A::$OPTIONS['password1']);

	    if(A::$OPTIONS['testmode'])
	    $url="http://test.robokassa.ru/Index.aspx";
	    else
	    $url="http://merchant.roboxchange.com/Index.aspx";

	    $url.="?MrchLogin={$mrh_login}";
	    $url.="&OutSum={$out_summ}";
	    $url.="&InvId={$inv_id}";
	    $url.="&Desc={$inv_desc}";
	    $url.="&SignatureValue=$crc";
	    $url.="&IncCurrLabel=YandexMerchantOceanR";
	    $url.="&Culture=ru";

	    A::goUrl($url);
	  }
    }
    A::goUrl(getSectionLink(SECTION));
  }

  function createData()
  {
    if($idorder=A_Session::get($this->section."_idorder",0))
    { if($order=A::$DB->getRowById($idorder,$this->section."_orders"))
      { $order['basket']=!empty($order['basket'])?@unserialize($order['basket']):array();
		$order['userdata']=!empty($order['userdata'])?@unserialize($order['userdata']):array();
		$all=array('count'=>0,'oldsum'=>0,'sum'=>0,'discount'=>0);
		foreach($order['basket'] as $i=>$row)
		{ $all['count']+=$row['count'];
	      $all['oldsum']+=$row['oldsum'];
	      $all['sum']+=$row['sum'];
	      $all['discount']+=$row['discount'];
        }
		$this->Assign("order",$order);
        $this->Assign("basket",$order['basket']);
        $this->Assign("data",$order['userdata']);
        $this->Assign('all',$all);

        switch($this->page)
        { case 'main':

            // ----------- ДОПОЛНИТЕЛЬНЫЕ ДАННЫЕ ДЛЯ РОБОКАССЫ --------------------------
            $inv_id=$order['id']; // получаем id заказа
            $this->Assign("inv_id",$inv_id); // {$inv_id}

            $mrh_login=A::$OPTIONS['login']; // получаем логин Робокассы
            $this->Assign("mrh_login",$mrh_login); // {$mrh_login}

            $inv_desc = urlencode(HOSTNAME.": оплата заказа №{$inv_id}"); // формирмируем оповещение заказа
            $this->Assign("inv_desc",$inv_desc); // {$inv_desc}

            $out_summ = (float)$order['sum']; // сумма заказа
            $this->Assign("out_summ",$out_summ); // {$out_summ}

            if($out_summ==0)
            A::goUrl(getSectionLink(SECTION));

            $crc  = md5("$mrh_login:$out_summ:$inv_id:".A::$OPTIONS['password1']); // Цифровая подпись
            $this->Assign("crc",$crc); // {$crc}

            if(A::$OPTIONS['testmode'])
	        $url="http://test.robokassa.ru/Index.aspx";
	        else
	        $url="http://merchant.roboxchange.com/Index.aspx";

            $this->Assign("url_robokassa",$url); // {$url_robokassa}

            // --------------------------------------------------------------------------

            $this->Assign("paylink",getSectionLink(SECTION)."?action=pay&id=".$order['id']."&code=".md5(SECTION.$order['date']));
            $this->AddNavigation(SECTION_NAME);
			return;
	      case 'success':
          case 'fail':
            $this->AddNavigation(SECTION_NAME,getSectionLink(SECTION));
            return;
          default:
		    return;
        }
      }
    }
    A::goUrl(getSectionLink($this->section)."message.html");
  }
}

A::$MAINFRAME = new RoboPayModule;